diff --git a/src/imports/folderlistmodel/fileinfothread.cpp b/src/imports/folderlistmodel/fileinfothread.cpp
index 4aa43b2..f7587c2 100644
--- a/src/imports/folderlistmodel/fileinfothread.cpp
+++ b/src/imports/folderlistmodel/fileinfothread.cpp
@@ -59,6 +59,7 @@ FileInfoThread::FileInfoThread(QObject *parent)
       showDirs(true),
       showDirsFirst(false),
       showDotAndDotDot(false),
+      showHidden(false),
       showOnlyReadable(false)
 {
 #ifndef QT_NO_FILESYSTEMWATCHER
@@ -176,6 +177,15 @@ void FileInfoThread::setShowDotAndDotDot(bool on)
     condition.wakeAll();
 }
 
+void FileInfoThread::setShowHidden(bool on)
+{
+    QMutexLocker locker(&mutex);
+    showHidden = on;
+    folderUpdate = true;
+    needUpdate = true;
+    condition.wakeAll();
+}
+
 void FileInfoThread::setShowOnlyReadable(bool on)
 {
     QMutexLocker locker(&mutex);
@@ -231,6 +241,8 @@ void FileInfoThread::getFileInfos(const QString &path)
         filter = filter | QDir::NoDot | QDir::NoDotDot;
     else if (path == rootPath)
         filter = filter | QDir::NoDotDot;
+    if (showHidden)
+        filter = filter | QDir::Hidden;
     if (showOnlyReadable)
         filter = filter | QDir::Readable;
     if (showDirsFirst)
diff --git a/src/imports/folderlistmodel/fileinfothread_p.h b/src/imports/folderlistmodel/fileinfothread_p.h
index d50361d..d54b2df 100644
--- a/src/imports/folderlistmodel/fileinfothread_p.h
+++ b/src/imports/folderlistmodel/fileinfothread_p.h
@@ -74,6 +74,7 @@ public:
     void setShowDirs(bool showFolders);
     void setShowDirsFirst(bool show);
     void setShowDotAndDotDot(bool on);
+    void setShowHidden(bool on);
     void setShowOnlyReadable(bool on);
 
 public Q_SLOTS:
@@ -107,6 +108,7 @@ private:
     bool showDirs;
     bool showDirsFirst;
     bool showDotAndDotDot;
+    bool showHidden;
     bool showOnlyReadable;
 };
 
diff --git a/src/imports/folderlistmodel/plugins.qmltypes b/src/imports/folderlistmodel/plugins.qmltypes
index 20914f4..1d451e9 100644
--- a/src/imports/folderlistmodel/plugins.qmltypes
+++ b/src/imports/folderlistmodel/plugins.qmltypes
@@ -33,6 +33,7 @@ Module {
         Property { name: "showDirs"; type: "bool" }
         Property { name: "showDirsFirst"; type: "bool" }
         Property { name: "showDotAndDotDot"; type: "bool" }
+        Property { name: "showHidden"; type: "bool" }
         Property { name: "showOnlyReadable"; type: "bool" }
         Property { name: "count"; type: "int"; isReadonly: true }
         Signal { name: "rowCountChanged" }
diff --git a/src/imports/folderlistmodel/qquickfolderlistmodel.cpp b/src/imports/folderlistmodel/qquickfolderlistmodel.cpp
index 7cab257..914247a 100644
--- a/src/imports/folderlistmodel/qquickfolderlistmodel.cpp
+++ b/src/imports/folderlistmodel/qquickfolderlistmodel.cpp
@@ -56,7 +56,8 @@ public:
     QQuickFolderListModelPrivate(QQuickFolderListModel *q)
         : q_ptr(q),
           sortField(QQuickFolderListModel::Name), sortReversed(false), showFiles(true),
-          showDirs(true), showDirsFirst(false), showDotAndDotDot(false), showOnlyReadable(false)
+          showDirs(true), showDirsFirst(false), showDotAndDotDot(false), showOnlyReadable(false),
+          showHidden(false)
     {
         nameFilters << QLatin1String("*");
     }
@@ -76,6 +77,7 @@ public:
     bool showDirsFirst;
     bool showDotAndDotDot;
     bool showOnlyReadable;
+    bool showHidden;
 
     ~QQuickFolderListModelPrivate() {}
     void init();
@@ -271,9 +273,9 @@ QString QQuickFolderListModelPrivate::resolvePath(const QUrl &path)
     that are applied to names of files and directories, causing only those that
     match the filters to be exposed.
 
-    Directories can be included or excluded using the \l showDirs property, and
+    Directories can be included or excluded using the \l showDirs property,
     navigation directories can also be excluded by setting the \l showDotAndDotDot
-    property to false.
+    property to false, hidden files -- by \l showHidden.
 
     It is sometimes useful to limit the files and directories exposed to those
     that the user can access. The \l showOnlyReadable property can be set to
@@ -721,6 +723,30 @@ void  QQuickFolderListModel::setShowDotAndDotDot(bool on)
     }
 }
 
+
+/*!
+    \qmlproperty bool FolderListModel::showHidden
+
+    If true, hidden files and directories are included in the model; otherwise
+    they are excluded.
+
+    By default, this property is false.
+*/
+bool QQuickFolderListModel::showHidden() const
+{
+    Q_D(const QQuickFolderListModel);
+    return d->showHidden;
+}
+
+void QQuickFolderListModel::setShowHidden(bool on)
+{
+    Q_D(QQuickFolderListModel);
+
+    if (on != d->showHidden) {
+        d->fileInfoThread.setShowHidden(on);
+    }
+}
+
 /*!
     \qmlproperty bool FolderListModel::showOnlyReadable
 
diff --git a/src/imports/folderlistmodel/qquickfolderlistmodel.h b/src/imports/folderlistmodel/qquickfolderlistmodel.h
index 3bf9a21..cdf7e06 100644
--- a/src/imports/folderlistmodel/qquickfolderlistmodel.h
+++ b/src/imports/folderlistmodel/qquickfolderlistmodel.h
@@ -73,6 +73,7 @@ class QQuickFolderListModel : public QAbstractListModel, public QQmlParserStatus
     Q_PROPERTY(bool showDirs READ showDirs WRITE setShowDirs)
     Q_PROPERTY(bool showDirsFirst READ showDirsFirst WRITE setShowDirsFirst)
     Q_PROPERTY(bool showDotAndDotDot READ showDotAndDotDot WRITE setShowDotAndDotDot)
+    Q_PROPERTY(bool showHidden READ showHidden WRITE setShowHidden)
     Q_PROPERTY(bool showOnlyReadable READ showOnlyReadable WRITE setShowOnlyReadable)
     Q_PROPERTY(int count READ count NOTIFY countChanged)
 //![class props]
@@ -131,6 +132,8 @@ public:
     void setShowDirsFirst(bool showDirsFirst);
     bool showDotAndDotDot() const;
     void setShowDotAndDotDot(bool on);
+    bool showHidden() const;
+    void setShowHidden(bool on);
     bool showOnlyReadable() const;
     void setShowOnlyReadable(bool on);
 //![prop funcs]