diff --git a/src/gui/painting/qpainter.cpp b/src/gui/painting/qpainter.cpp
index 424ed55..6d3ab35 100644
--- a/src/gui/painting/qpainter.cpp
+++ b/src/gui/painting/qpainter.cpp
@@ -7337,6 +7337,9 @@ QPaintDevice *QPainter::redirected(const QPaintDevice *device, QPoint *offset)
     return 0;
 }
 
+QString debugHieroglyph(const QStringRef &r);
+
+
 void qt_format_text(const QFont &fnt, const QRectF &_r,
                     int tf, const QString& str, QRectF *brect,
                     int tabstops, int *ta, int tabarraylen,
@@ -7347,11 +7350,16 @@ void qt_format_text(const QFont &fnt, const QRectF &_r,
                     tabstops, ta, tabarraylen,
                     painter);
 }
+
+
+
+
 void qt_format_text(const QFont &fnt, const QRectF &_r,
                     int tf, const QTextOption *option, const QString& str, QRectF *brect,
                     int tabstops, int *ta, int tabarraylen,
                     QPainter *painter)
 {
+    qDebug() << __FUNCTION__ << fnt.family() <<debugHieroglyph(str.midRef(0, str.size()));
 
     Q_ASSERT( !((tf & ~Qt::TextDontPrint)!=0 && option!=0) ); // we either have an option or flags
 
diff --git a/src/gui/text/qfont.cpp b/src/gui/text/qfont.cpp
index 49b5a9b..c4e405f 100644
--- a/src/gui/text/qfont.cpp
+++ b/src/gui/text/qfont.cpp
@@ -67,7 +67,7 @@
 #include <QtCore/QMutexLocker>
 #include <QtCore/QMutex>
 
-// #define QFONTCACHE_DEBUG
+#define QFONTCACHE_DEBUG
 #ifdef QFONTCACHE_DEBUG
 #  define FC_DEBUG qDebug
 #else
@@ -205,6 +205,7 @@ extern QMutex *qt_fontdatabase_mutex();
 
 QFontEngine *QFontPrivate::engineForScript(int script) const
 {
+    qDebug() << __FUNCTION__ << script;
     QMutexLocker locker(qt_fontdatabase_mutex());
     if (script <= QChar::Script_Latin)
         script = QChar::Script_Common;
@@ -2724,6 +2725,7 @@ QFontEngineData *QFontCache::findEngineData(const QFontDef &def) const
 
 void QFontCache::insertEngineData(const QFontDef &def, QFontEngineData *engineData)
 {
+    qDebug() << __FUNCTION__ << def.family ;
 #ifdef QFONTCACHE_DEBUG
     FC_DEBUG("QFontCache: inserting new engine data %p", engineData);
     if (engineDataCache.contains(def)) {
@@ -2741,12 +2743,16 @@ void QFontCache::insertEngineData(const QFontDef &def, QFontEngineData *engineDa
 
 QFontEngine *QFontCache::findEngine(const Key &key)
 {
+    qDebug() << __FUNCTION__ << key.def.family << "Script="<< key.script << key.def.fallBackFamilies;
     EngineCache::Iterator it = engineCache.find(key),
                          end = engineCache.end();
-    if (it == end) return 0;
+    if (it == end) {
+        qDebug() << __FUNCTION__ << "returns NONE";
+        return 0;
+    }
     // found... update the hitcount and timestamp
     updateHitCountAndTimeStamp(it.value());
-
+    qDebug() << __FUNCTION__ << "returns" << it.value().data;
     return it.value().data;
 }
 
@@ -2764,6 +2770,7 @@ void QFontCache::updateHitCountAndTimeStamp(Engine &value)
 
 void QFontCache::insertEngine(const Key &key, QFontEngine *engine, bool insertMulti)
 {
+    qDebug() << __FUNCTION__ << key.def.family << key.script;
 #ifdef QFONTCACHE_DEBUG
     FC_DEBUG("QFontCache: inserting new engine %p, refcount %d", engine, engine->ref.load());
     if (!insertMulti && engineCache.contains(key)) {
diff --git a/src/gui/text/qfontdatabase.cpp b/src/gui/text/qfontdatabase.cpp
index ff050d1..5c6f93e 100644
--- a/src/gui/text/qfontdatabase.cpp
+++ b/src/gui/text/qfontdatabase.cpp
@@ -60,14 +60,14 @@
 #include <algorithm>
 
 
-// #define QFONTDATABASE_DEBUG
+#define QFONTDATABASE_DEBUG
 #ifdef QFONTDATABASE_DEBUG
 #  define FD_DEBUG qDebug
 #else
 #  define FD_DEBUG if (false) qDebug
 #endif
 
-// #define FONT_MATCH_DEBUG
+#define FONT_MATCH_DEBUG
 #ifdef FONT_MATCH_DEBUG
 #  define FM_DEBUG qDebug
 #else
@@ -501,11 +501,18 @@ static const int scriptForWritingSystem[] = {
 
 int qt_script_for_writing_system(QFontDatabase::WritingSystem writingSystem)
 {
-    return scriptForWritingSystem[writingSystem];
+   int r = scriptForWritingSystem[writingSystem];
+   if (writingSystem)
+       qDebug() << __FUNCTION__ << "returns " << r << "for" << writingSystem;
+   return r;
 }
 
-
-
+int qt_writing_system_for_script(int s)
+{
+    const int *e = scriptForWritingSystem + sizeof(scriptForWritingSystem)/sizeof(int);
+    const int *p = std::find(scriptForWritingSystem, e, s);
+    return p != e ? *p : -1;
+}
 
 /*!
   \internal
@@ -705,6 +712,7 @@ unsigned int bestFoundry(int script, unsigned int score, int styleStrategy,
     Q_UNUSED(force_encoding_id);
     Q_UNUSED(script);
     Q_UNUSED(pitch);
+    qDebug() << __FUNCTION__ << "script="<< script << family->name << foundry_name;
 
     desc->foundry = 0;
     desc->style = 0;
@@ -845,11 +853,13 @@ static bool matchFamilyName(const QString &familyName, QtFontFamily *f)
     \internal
 
     Tries to find the best match for a given request and family/foundry
-*/
+match() */
 static void match(int script, const QFontDef &request,
                   const QString &family_name, const QString &foundry_name, int force_encoding_id,
                   QtFontDesc *desc, const QList<int> &blacklistedFamilies)
 {
+    qDebug() << __FUNCTION__ << ">script=" << script << request.family << request.fallBackFamilies
+             << "family_name" << family_name << foundry_name;
     Q_UNUSED(force_encoding_id);
 
     QtFontStyle::Key styleKey;
@@ -889,8 +899,11 @@ static void match(int script, const QFontDef &request,
         test.family = db->families[x];
         test.familyIndex = x;
 
-        if (!matchFamilyName(family_name, test.family))
+        if (!matchFamilyName(family_name, test.family)) {
+//            qDebug() << x << test.family->name << test.family->aliases << "failed matchFamilyName";
             continue;
+        }
+
 
         if (family_name.isEmpty())
             load(test.family->name, script);
@@ -901,13 +914,27 @@ static void match(int script, const QFontDef &request,
         for (int ws = 1; !supported && ws < QFontDatabase::WritingSystemsCount; ++ws) {
             if (scriptForWritingSystem[ws] != script)
                 continue;
-            if (test.family->writingSystems[ws] & QtFontFamily::Supported)
+            if (test.family->writingSystems[ws] & QtFontFamily::Supported) {
                 supported = true;
+//                qDebug() << __FUNCTION__ << "script="<< script << "ws" << ws << "supported!";
+            } else {
+//                qDebug() << __FUNCTION__ << "script="<< script << "ws" << ws << "unsupported!";
+            }
         }
         if (!supported) {
             // family not supported in the script we want
+/*
+            QDebug nsp = qDebug().nospace();
+            nsp << x <<  test.family->name << test.family->aliases
+                     << "failed writing system " <<qt_writing_system_for_script(script)
+                     << " script: "<< script << " test family supports ws:";
+            for (int i = 0; i <  QFontDatabase::WritingSystemsCount ; i++)
+                if (test.family->writingSystems[i] & QtFontFamily::Supported)
+                    nsp  << i << ", ";
+*/
             continue;
         }
+        qDebug() << "Examining" << x << test.family->name << test.family->aliases;
 
         // as we know the script is supported, we can be sure
         // to find a matching font here.
@@ -928,9 +955,15 @@ static void match(int script, const QFontDef &request,
             score = newscore;
             *desc = test;
         }
+//        qDebug() << x <<  test.family->name << test.family->aliases << "newscore" << newscore;
         if (newscore < 10) // xlfd instead of FT... just accept it
             break;
     }
+    if (desc && desc->family) {
+        qDebug() << __FUNCTION__ << "<script=" << script << request.family << "MATCH"<< desc->family->name;
+    } else {
+        qDebug() << __FUNCTION__ << "<script=" << script << request.family << "NOMATCH";
+    }
 }
 
 static QString styleStringHelper(int weight, QFont::Style style)
diff --git a/src/gui/text/qfontdatabase_qpa.cpp b/src/gui/text/qfontdatabase_qpa.cpp
index fddbb11..180acbe 100644
--- a/src/gui/text/qfontdatabase_qpa.cpp
+++ b/src/gui/text/qfontdatabase_qpa.cpp
@@ -52,6 +52,18 @@
 
 QT_BEGIN_NAMESPACE
 
+
+QDebug operator<<(QDebug d, const QSupportedWritingSystems &ws)
+{
+    QDebug nsp =d.nospace();
+    nsp << "QSupportedWritingSystems: ";
+    for (int i = 0; i <QFontDatabase::WritingSystemsCount; ++i) {
+        if (ws.supported(static_cast<QFontDatabase::WritingSystem>(i)))
+            nsp << i << ", ";
+    }
+    return d;
+}
+
 void qt_registerFont(const QString &familyName, const QString &stylename,
                      const QString &foundryname, int weight,
                      QFont::Style style, int stretch, bool antialiased,
@@ -59,7 +71,8 @@ void qt_registerFont(const QString &familyName, const QString &stylename,
                      const QSupportedWritingSystems &writingSystems, void *handle)
 {
     QFontDatabasePrivate *d = privateDb();
-//    qDebug() << "Adding font" << familyName << weight << style << pixelSize << antialiased;
+    qDebug() << __FUNCTION__ << "Adding font" << familyName <<  stylename << foundryname
+                <<"wg" << weight <<  "ws" << writingSystems;
     QtFontStyle::Key styleKey;
     styleKey.style = style;
     styleKey.weight = weight;
@@ -131,6 +144,7 @@ static QStringList fallbackFamilies(const QString &family, QFont::Style style, Q
             i--;
         }
     }
+    qDebug() << __FUNCTION__ << family << "returns "<< retList;
     return retList;
 }
 
@@ -166,6 +180,7 @@ QFontEngine *loadSingleEngine(int script,
                               QtFontFoundry *foundry,
                               QtFontStyle *style, QtFontSize *size)
 {
+    qDebug() << __FUNCTION__ << request.family << script;
     Q_UNUSED(foundry);
 
     Q_ASSERT(size);
@@ -180,6 +195,7 @@ QFontEngine *loadSingleEngine(int script,
     def.pixelSize = pixelSize;
 
     QFontCache::Key key(def,script);
+    qDebug() << __FUNCTION__ <<  key.def.family;
     QFontEngine *engine = QFontCache::instance()->findEngine(key);
     if (!engine) {
         engine = pfdb->fontEngine(def, QChar::Script(script), size->handle);
@@ -198,6 +214,7 @@ QFontEngine *loadEngine(int script, const QFontDef &request,
                         QtFontStyle *style, QtFontSize *size)
 {
 
+    qDebug() << __FUNCTION__ << request.family << script;
     QFontEngine *engine = loadSingleEngine(script, request, foundry, style, size);
     //make sure that the db has all fallback families
     if (engine && engine->type() != QFontEngine::Multi
@@ -282,6 +299,7 @@ QFontDatabase::findFont(int script, const QFontPrivate *fp,
                         const QFontDef &request, bool multi)
 {
     QMutexLocker locker(fontDatabaseMutex());
+    qDebug() << __FUNCTION__ << '>'<< script << request.family << request.fallBackFamilies << multi;
 
     const int force_encoding_id = -1;
 
@@ -293,6 +311,7 @@ QFontDatabase::findFont(int script, const QFontPrivate *fp,
     engine = QFontCache::instance()->findEngine(key);
     if (engine) {
         FM_DEBUG("Cache hit level 1");
+        qDebug() << __FUNCTION__ << "returning cached" << engine;
         return engine;
     }
 
@@ -303,17 +322,21 @@ QFontDatabase::findFont(int script, const QFontPrivate *fp,
     if (qt_enable_test_font && request.family == QLatin1String("__Qt__Box__Engine__")) {
         engine =new QTestFontEngine(request.pixelSize);
         engine->fontDef = request;
+        qDebug() << __FUNCTION__ << "box" << engine;
     }
 
     QtFontDesc desc;
+    qDebug() << __FUNCTION__ << "Calling match family="<< family_name << engine;
     match(script, request, family_name, foundry_name, force_encoding_id, &desc);
     if (desc.family != 0 && desc.foundry != 0 && desc.style != 0) {
         engine = loadEngine(script, request, desc.family, desc.foundry, desc.style, desc.size);
+        qDebug() << __FUNCTION__ << "loadEngine" << engine;
     } else {
-        FM_DEBUG("  NO MATCH FOUND\n");
+        qDebug() << __FUNCTION__ << "NO MATCH";
     }
 
     if (engine && engine->type() != QFontEngine::TestFontEngine) {
+        qDebug() << __FUNCTION__ << "NONTEST";
         initFontDef(desc, request, &engine->fontDef, engine->type() == QFontEngine::Multi);
 
         if (fp) {
@@ -326,6 +349,7 @@ QFontDatabase::findFont(int script, const QFontPrivate *fp,
     }
 
     if (!engine) {
+        qDebug() << __FUNCTION__ << "Fallbacks";
         if (!request.family.isEmpty()) {
             QStringList fallbacks = request.fallBackFamilies
                                   + fallbackFamilies(request.family,
@@ -337,6 +361,7 @@ QFontDatabase::findFont(int script, const QFontPrivate *fp,
                 QFontDef def = request;
                 def.family = fallbacks.at(i);
                 QFontCache::Key key(def, script, multi ? 1 : 0);
+                qDebug() << __FUNCTION__ <<  "fallback"<< i << fallbacks.size() << key.def.family;
                 engine = QFontCache::instance()->findEngine(key);
                 if (!engine) {
                     QtFontDesc desc;
@@ -350,10 +375,13 @@ QFontDatabase::findFont(int script, const QFontPrivate *fp,
                     }
                 }
             }
+            qDebug() << __FUNCTION__ <<  "done loop" << engine;
         }
 
-        if (!engine)
+        if (!engine) {
             engine = new QFontEngineBox(request.pixelSize);
+            qDebug() << __FUNCTION__ <<  "QFontEngineBox";
+        }
 
         FM_DEBUG("returning box engine");
     }
@@ -363,13 +391,14 @@ QFontDatabase::findFont(int script, const QFontPrivate *fp,
     } else {
         engine->fontDef.pointSize = request.pointSize;
     }
-
+    qDebug() << __FUNCTION__ <<  '<' << engine;
     return engine;
 }
 
 void QFontDatabase::load(const QFontPrivate *d, int script)
 {
     QFontDef req = d->request;
+    qDebug() << __FUNCTION__ << '>'<< req.family << script;
 
     if (req.pixelSize == -1) {
         req.pixelSize = floor(((req.pointSize * d->dpi) / 72) * 100 + 0.5) / 100;
@@ -394,7 +423,7 @@ void QFontDatabase::load(const QFontPrivate *d, int script)
     // the cached engineData could have already loaded the engine we want
     if (d->engineData->engines[script])
         return;
-
+    qDebug() << __FUNCTION__ <<  key.def.family;
     QFontEngine *fe = QFontCache::instance()->findEngine(key);
 
     // list of families to try
@@ -438,19 +467,24 @@ void QFontDatabase::load(const QFontPrivate *d, int script)
     if (fe->symbol || (d->request.styleStrategy & QFont::NoFontMerging)) {
         for (int i = 0; i < QChar::ScriptCount; ++i) {
             if (!d->engineData->engines[i]) {
+                qDebug() << '1' << i << fe;
                 d->engineData->engines[i] = fe;
                 fe->ref.ref();
             }
         }
     } else {
+        qDebug() << '2' << script << fe;
         d->engineData->engines[script] = fe;
         fe->ref.ref();
     }
+    qDebug() << __FUNCTION__ << '<';
 }
 
 QString QFontDatabase::resolveFontFamilyAlias(const QString &family)
 {
-    return QGuiApplicationPrivate::platformIntegration()->fontDatabase()->resolveFontFamilyAlias(family);
+    const QString r = QGuiApplicationPrivate::platformIntegration()->fontDatabase()->resolveFontFamilyAlias(family);
+    qDebug() <<  __FUNCTION__ << family << r;
+    return r;
 }
 
 QT_END_NAMESPACE
diff --git a/src/gui/text/qfontengine.cpp b/src/gui/text/qfontengine.cpp
index 7d1afbb..1bb268d 100644
--- a/src/gui/text/qfontengine.cpp
+++ b/src/gui/text/qfontengine.cpp
@@ -1303,6 +1303,7 @@ QFixed QFontEngine::lastRightBearing(const QGlyphLayout &glyphs, bool round)
 QFontEngineBox::QFontEngineBox(int size)
     : _size(size)
 {
+    qDebug("%s", __FUNCTION__);
     cache_cost = sizeof(QFontEngineBox);
 }
 
@@ -1900,4 +1901,13 @@ QFontEngine::Type QTestFontEngine::type() const
     return TestFontEngine;
 }
 
+Q_GUI_EXPORT QDebug operator<<(QDebug d, const QFontEngine *e)
+{
+    if (e)
+        d << "QFontEngine" << e->type() << e->fontDef.family <<e->fontDef.fallBackFamilies;
+    else
+        d << "QFontEngine: <NULL>";
+    return d;
+}
+
 QT_END_NAMESPACE
diff --git a/src/gui/text/qfontengine_p.h b/src/gui/text/qfontengine_p.h
index 07be498..c3c9759 100644
--- a/src/gui/text/qfontengine_p.h
+++ b/src/gui/text/qfontengine_p.h
@@ -64,6 +64,7 @@
 
 QT_BEGIN_NAMESPACE
 
+class QDebug;
 class QPainterPath;
 
 struct QGlyphLayout;
@@ -441,6 +442,8 @@ public:
     virtual Type type() const;
 };
 
+Q_GUI_EXPORT QDebug operator<<(QDebug d, const QFontEngine *);
+
 QT_END_NAMESPACE
 
 
diff --git a/src/gui/text/qtextlayout.cpp b/src/gui/text/qtextlayout.cpp
index 66341e1..3e948d9 100644
--- a/src/gui/text/qtextlayout.cpp
+++ b/src/gui/text/qtextlayout.cpp
@@ -767,6 +767,23 @@ bool QTextLayout::isValidCursorPosition(int pos) const
     inserted into the layout, the QTextLine returned will not be valid
     (isValid() will return false).
 */
+
+QString debugHieroglyph(const QStringRef &r)
+{
+    QString s ;
+    QTextStream str(&s);
+    for (int i = 0; i < r.size(); ++i) {
+        const QChar c = r.at(i);
+        const ushort  u = c.unicode();
+        str << hex << showbase << r.at(i).unicode() << dec << ' ';
+        if (u >= 32 && u < 128)
+            str << '\'' << char(u) << "' ";
+        else
+            str << " [script " << c.script() << "] ";
+    }
+    return s;
+}
+
 QTextLine QTextLayout::createLine()
 {
 #ifndef QT_NO_DEBUG
@@ -789,6 +806,8 @@ QTextLine QTextLayout::createLine()
             return QTextLine();
     }
 
+    qDebug() << __FUNCTION__  << from << strlen << d->layoutData->string.size() << debugHieroglyph(d->layoutData->string.midRef(from, strlen));
+
     QScriptLine line;
     line.from = from;
     line.length = -1;
diff --git a/src/platformsupport/fontdatabases/fontconfig/qfontconfigdatabase.cpp b/src/platformsupport/fontdatabases/fontconfig/qfontconfigdatabase.cpp
index 8c3ca2d..67f4de6 100644
--- a/src/platformsupport/fontdatabases/fontconfig/qfontconfigdatabase.cpp
+++ b/src/platformsupport/fontdatabases/fontconfig/qfontconfigdatabase.cpp
@@ -605,7 +605,8 @@ QFontEngine *QFontconfigDatabase::fontEngine(const QFontDef &f, QChar::Script sc
         delete engine;
         engine = 0;
     } else if (!engine->supportsScript(script)) {
-        qWarning("  OpenType support missing for script %d", int(script));
+
+        qWarning("%s  OpenType support missing for script %d, returning 0", __FUNCTION__,int(script));
         delete engine;
         engine = 0;
     }
@@ -681,7 +682,7 @@ QStringList QFontconfigDatabase::fallbacksForFamily(const QString &family, QFont
         }
         FcFontSetDestroy(fontSet);
     }
-//    qDebug() << "fallbackFamilies for:" << family << style << styleHint << script << fallbackFamilies;
+    qDebug() << "fallbackFamilies for:" << family << style << styleHint << script << fallbackFamilies;
 
     return fallbackFamilies;
 }
diff --git a/src/plugins/platforms/windows/qwindowsfontdatabase.cpp b/src/plugins/platforms/windows/qwindowsfontdatabase.cpp
index c2c8c15..becc3bc 100644
--- a/src/plugins/platforms/windows/qwindowsfontdatabase.cpp
+++ b/src/plugins/platforms/windows/qwindowsfontdatabase.cpp
@@ -860,7 +860,7 @@ static bool addFontToDatabase(const QString &familyName, uchar charSet,
     const QFont::Stretch stretch = QFont::Unstretched;
 
 #ifndef QT_NO_DEBUG_OUTPUT
-    if (QWindowsContext::verboseFonts > 2) {
+    if (1 || QWindowsContext::verboseFonts > 2) {
         QDebug nospace = qDebug().nospace();
         nospace << __FUNCTION__ << familyName << charSet
                  << "TTF=" << ttf;
@@ -976,7 +976,7 @@ void QWindowsFontDatabase::populateFontDatabase()
 void QWindowsFontDatabase::populate(const QString &family)
     {
 
-    if (QWindowsContext::verboseFonts)
+    if (1|| QWindowsContext::verboseFonts)
         qDebug() << __FUNCTION__ << m_families.size() << family;
 
     HDC dummy = GetDC(0);
@@ -1054,6 +1054,7 @@ QFontEngine * QWindowsFontDatabase::fontEngine(const QFontDef &fontDef, QChar::S
 
 QFontEngine *QWindowsFontDatabase::fontEngine(const QByteArray &fontData, qreal pixelSize, QFont::HintingPreference hintingPreference)
 {
+    qDebug() << __FUNCTION__ << "DATA"<< fontData;
     EmbeddedFont font(fontData);
     QFontEngine *fontEngine = 0;
 
@@ -1555,6 +1556,7 @@ LOGFONT QWindowsFontDatabase::fontDefToLOGFONT(const QFontDef &request)
 
 static QStringList extraTryFontsForFamily(const QString& family)
 {
+    qDebug() << __FUNCTION__ << family;
     QStringList result;
     QFontDatabase db;
     if (!db.writingSystems(family).contains(QFontDatabase::Symbol)) {
@@ -1589,6 +1591,7 @@ static QStringList extraTryFontsForFamily(const QString& family)
             ++tf;
         }
     }
+    qDebug() << __FUNCTION__ << family << result;
     return result;
 }
 
@@ -1625,7 +1628,7 @@ QStringList QWindowsFontDatabase::fallbacksForFamily(const QString &family, QFon
 
     result.append(extraTryFontsForFamily(family));
 
-    if (QWindowsContext::verboseFonts)
+    if (1||QWindowsContext::verboseFonts)
         qDebug() << __FUNCTION__ << family << style << styleHint
                  << script << result << m_families.size();
     return result;
@@ -1637,6 +1640,7 @@ QFontEngine *QWindowsFontDatabase::createEngine(int script, const QFontDef &requ
                                                 const QStringList &family_list,
                                                 const QSharedPointer<QWindowsFontEngineData> &data)
 {
+    qDebug() << __FUNCTION__ << request.family;
     LOGFONT lf;
     memset(&lf, 0, sizeof(LOGFONT));
 
@@ -1758,6 +1762,7 @@ QFontEngine *QWindowsFontDatabase::createEngine(int script, const QFontDef &requ
 
         // Also check for OpenType tables when using complex scripts
         if (!few->supportsScript(QChar::Script(script))) {
+            qDebug() << __FUNCTION__ <<"returns 0 due to missing OpenType" << request.family;
             qWarning("  OpenType support missing for script %d", int(script));
             delete few;
             return 0;
@@ -1789,6 +1794,7 @@ QFontEngine *QWindowsFontDatabase::createEngine(int script, const QFontDef &requ
     if ((script == QChar::Script_Common || script == QChar::Script_Han)
             && !(request.styleStrategy & QFont::NoFontMerging)) {
         QStringList extraFonts = extraTryFontsForFamily(request.family);
+        qDebug() << __FUNCTION__ << "EX" << extraFonts;
         if (extraFonts.size()) {
             QStringList list = family_list;
             list.append(extraFonts);
diff --git a/src/plugins/platforms/windows/qwindowsfontengine.cpp b/src/plugins/platforms/windows/qwindowsfontengine.cpp
index 6c92811..4c62fc0 100644
--- a/src/plugins/platforms/windows/qwindowsfontengine.cpp
+++ b/src/plugins/platforms/windows/qwindowsfontengine.cpp
@@ -1347,7 +1347,7 @@ QWindowsMultiFontEngine::QWindowsMultiFontEngine(QFontEngine *first, const QStri
         : QFontEngineMulti(fallbacks.size()+1),
           fallbacks(fallbacks)
 {
-    if (QWindowsContext::verboseFonts)
+    if (1|| QWindowsContext::verboseFonts)
         qDebug() <<  __FUNCTION__ << engines.size() << first << first->fontDef.family << fallbacks;
     engines[0] = first;
     first->ref.ref();